<?php
header('Access-Control-Allow-Origin: *; Content-Type:text/html; charset=UTF-8');

if(! array_key_exists('reg', $_REQUEST)) // Тестовый запрос. Сервер виден.
    exit('{ "check": "1" }');

$win1251 = array_key_exists('win1251', $_REQUEST); // конвертируем для тупой 1С
 
include_once 'displayconnect.php';

// Если облако, то всегда передаем uid клиента в параметре key
if(isset($internetserver) && ! array_key_exists('key', $_REQUEST))
    if($win1251)
        exit(iconv("UTF-8", "windows-1251//TRANSLIT", '{ "result": "0", "error": "В запросе отсутствует ключ" }'));
    else
        exit('{ "result": "0", "error": "Your request is missing a key" }');

// Подключаемся к базе с параметрами из displayconnect.php
$link = new mysqli($server, $user, $password);
if($link->connect_errno)
    exit('{ "result": "0", "error": "' . $link->error . '" }');

$link->query('SET NAMES UTF8 COLLATE utf8_general_ci');
if($link->connect_errno)
    exit('{ "result": "0", "error": "' . $link->error . '" }');

// Если облако, проверяем, что пользователь зарегистрирован
if(isset($internetserver))
{
    $uid = filter_input(INPUT_POST, 'key', FILTER_SANITIZE_STRING);
    $res = $link->query("SELECT * FROM `{$dbname}`.`{$dbusers}` as `dbusers` WHERE (`dbusers`.`uid` = '{$uid}') LIMIT 1");
    if($link->connect_errno)
        exit('{ "result": "0", "error": "' . $link->error . '" }');

    if(($obj = $res->fetch_object()) === NULL)
        if($win1251)
            exit(iconv("UTF-8", "windows-1251//TRANSLIT", '{ "result": "0", "error": "В запросе неверный ключ" }'));
        else
            exit('{ "result": "0", "error": "Invalid key in request" }');
    else
        $userid = $obj->id;
}

$reg = $_REQUEST['reg'];

switch($reg)
{
    case 'check': // Просто тестовый запрос. Говорит, что база полключена корректно.
        exit('{ "result": "1" }');

    case 'open': // Начало работы клиента 
    // Удаляем из базы все временные данные (status = 0)
    // Записи со status = 1 и выше отвечают за построение страницы
        if($internetserver) // Если облако, по uid клиента
            $query = "DELETE FROM `{$dbname}`.`{$dbtable}` WHERE `{$dbtable}`.`parent_users` = '{$userid}' AND `{$dbtable}`.`status` = '0'";
        else
        {
            // Если сетевая версия, по localid, если локальная версия, то все
            $localid = filter_input(INPUT_POST, 'localid', FILTER_SANITIZE_STRING);
            if($localid === false || $localid === null)
                $localid = false;
            $query = "DELETE FROM `{$dbname}`.`{$dbtable}` WHERE (`{$dbtable}`.`status` = '0')" . ($localid === false ? '' : " AND (`{$dbtable}`.`localid` = '{$localid}')");
        }
        $link->query($query);
        if($link->connect_errno)
            exit('{ "result": "0", "error": "' . $link->error . '" }');

        exit('{ "result": "1" }');

    case 'clear': // Очищаем базу от всех записей
        if($internetserver)
            $query = "DELETE FROM `{$dbname}`.`{$dbtable}` WHERE `{$dbtable}`.`parent_users` = '{$userid}'";
        else
        {
            $localid = filter_input(INPUT_POST, 'localid', FILTER_SANITIZE_STRING);
            if($localid === false || $localid === null)
                $query = "TRUNCATE TABLE `{$dbname}`.`{$dbtable}`";
            else
                $query = "DELETE FROM `{$dbname}`.`{$dbtable}` WHERE `{$dbtable}`.`localid` = '{$localid}'";
        }
        $link->query($query);
        if($link->connect_errno)
            exit('{ "result": "0", "error": "' . $link->error . '" }');

        exit('{ "result": "1" }');

    case 'add': // Добавляем запись в базу. 

        if(array_key_exists('content', $_REQUEST))
        {
            $content = $_REQUEST['content'];
            if($win1251)
                $content = iconv('CP1251','UTF-8',$content); 
            if($content === false || $content === null)
                if($win1251)
                    exit(iconv("UTF-8", "windows-1251//TRANSLIT", '{ "result": "0", "error": "В запросе отсутствует или неправильный контент" }'));
                else
                    exit('{ "result": "0", "error": "Missing or invalid content in request" }');

            $localid = filter_input(INPUT_POST, 'localid', FILTER_SANITIZE_STRING);
            if($localid === false || $localid === null || isset($internetserver))
                $localid = false;

            $status = filter_input(INPUT_POST, 'status', FILTER_VALIDATE_INT);
            if($status === false || $status === null || $status === '0')
                $status = '0';
            else
            {
                // Если status записи не 0, то проверяем, что с этим статусом записей нет
                // Если есть, то записи с одинаковым статусом не дублируем, ничего не добавляем
                // Это нужно для разделения постоянных конструкций страницы (status > 0) 
                // от записей, передающих данные по текушим операциям (status = 0)
                // Постоянные конструкции считываем при старте. Данные - все время
                $res = $link->query("SELECT * FROM `{$dbname}`.`{$dbtable}` as `dbtable` WHERE (`dbtable`.`status` = '{$status}')" . (isset($internetserver) ? " AND (`dbtable`.`parent_users` = '{$userid}')" : ($localid === false ? '' : " AND (`dbtable`.`localid` = '{$localid}')")));
                if($link->connect_errno)
                    exit('{ "result": "0", "error": "' . $link->error . '" }');

                if($res->num_rows > 0)            
                    exit('{ "result": "1", "insert": "0" }');
            }            

            $query = $link->prepare("INSERT INTO `{$dbname}`.`{$dbtable}` (`status`,  `content`". (isset($internetserver) ? ", `parent_users`" : ($localid === false ? '' : ", `localid`")) . ") VALUES ('{$status}', ?" . (isset($internetserver) ? ", '{$userid}')" : ($localid === false ? ')' : ", '{$localid}')")));
            $query->bind_param('s', $content);
            $res = $query->execute();
            $query->close();

            if(! $res)
                exit('{ "result": "0", "error": "' . $link->error . '" }');
        }

        exit('{ "result": "1", "insert": "1" }');

    case 'create':
        $link->query("CREATE DATABASE IF NOT EXISTS `{$dbname}`");
        if($link->connect_errno)
            exit('{ "result": "0", "error": "' . $link->error . '" }');

        // status позволяет закрепить запись. они не дублируются, если статус не 0
        // parent_users - только у облака
        // localid - для разделения пользователей сетевой версии
        $link->query("CREATE TABLE IF NOT EXISTS `{$dbname}`.`{$dbtable}` (`id` INT(15) NOT NULL AUTO_INCREMENT,
`content` TEXT,
`status` INT," . (isset($internetserver) ? "
`parent_users` INT,
INDEX (`parent_users`)," : "
`localid` VARCHAR(20),
INDEX (`localid`),") . "
PRIMARY KEY(`id`))
CHARACTER SET utf8 
COLLATE utf8_general_ci");
        if($link->connect_errno)
            exit('{ "result": "0", "error": "' . $link->error . '" }');

        exit('{ "result": "1" }');

    case 'get':
    // Вернуть все записи из базы, начиная с какого-то id. В следующий раз с последнего полученного id + 1
    // Принцип: сперва id = 0. То есть, строим страницу (записи со status > 0), получаем данные
    // Потом только получаем данные. Записи со status > 0 уже не будут возвращаться, их id меньше, чем последний полученный
        $id = filter_input(INPUT_POST, 'id', FILTER_VALIDATE_INT);
        if($id === false || $id === null)
            if($win1251)
                exit(iconv("UTF-8", "windows-1251//TRANSLIT", '{ "result": "0", "error": "В запросе отсутствует id записи" }'));
            else
                exit('{ "result": "0", "error": "There is no record id in the request" }');

        $localid = filter_input(INPUT_POST, 'localid', FILTER_SANITIZE_STRING);
        if($localid === false || $localid === null || isset($internetserver))
            $localid = false;

        $res = $link->query("SELECT * FROM `{$dbname}`.`{$dbtable}` as `dbtable` WHERE (`dbtable`.`id` > '{$id}')" . (isset($internetserver) ? " AND (`dbtable`.`parent_users` = '{$userid}')" : ($localid === false ? '' : " AND (`dbtable`.`localid` = '{$localid}')")));
        if($link->connect_errno)
            exit('{ "result": "0", "error": "' . $link->error . '" }');

        $resarray = array();
        if($res !== false)
            while($obj = $res->fetch_object())
                $resarray[] = $obj;
        
        if(count($resarray) == 0)
            exit('{ "result": "1" }');
        $_ss = json_encode(array('result' => '1', 'content' => $resarray));
        $ss = str_replace(array('\t', '\n', '\r'), '', $_ss);

//file_put_contents('1.d', $ss);
        exit($ss);     
}

echo $win1251 ? iconv("UTF-8", "windows-1251//TRANSLIT", '{ "result": "0", "error": "Неправильный запрос" }') : '{ "result": "0", "error": "Неправильный запрос" }';
?>
