<?php
header('Access-Control-Allow-Origin: *; Content-Type:text/html; charset=UTF-8');

if(! array_key_exists('reg', $_REQUEST))
    exit('{ "check": "1" }');

$win1251 = array_key_exists('win1251', $_REQUEST); // для тупой 1С
 
include_once 'displayconnect.php';

if(isset($internetserver) && ! array_key_exists('key', $_REQUEST))
    if($win1251)
        exit(iconv("UTF-8", "windows-1251//TRANSLIT", '{ "result": "0", "error": "В запросе отсутствует ключ" }'));
    else
        exit('{ "result": "0", "error": "Your request is missing a key" }');
    
$link = new mysqli($server, $user, $password);
if($link->connect_errno)
    exit('{ "result": "0", "error": "' . $link->error . '" }');

$link->query('SET NAMES UTF8 COLLATE utf8_general_ci');
if($link->connect_errno)
    exit('{ "result": "0", "error": "' . $link->error . '" }');

//$link->real_escape_string('"qwerty"');

if(isset($internetserver))
{
    $uid = filter_input(INPUT_POST, 'key', FILTER_SANITIZE_STRING);
    $res = $link->query("SELECT * FROM `{$dbname}`.`{$dbusers}` as `dbusers` WHERE (`dbusers`.`uid` = '{$uid}') LIMIT 1");
    if($link->connect_errno)
        exit('{ "result": "0", "error": "' . $link->error . '" }');

    if(($obj = $res->fetch_object()) === NULL)
        if($win1251)
            exit(iconv("UTF-8", "windows-1251//TRANSLIT", '{ "result": "0", "error": "В запросе неверный ключ" }'));
        else
            exit('{ "result": "0", "error": "Invalid key in request" }');
    else
        $userid = $obj->id;
}

$reg = $_REQUEST['reg'];

switch($reg)
{
    case 'check': // Просто тестовый запрос
        exit('{ "result": "1" }');

    case 'open': 
        if($internetserver)
            $query = "DELETE FROM `{$dbname}`.`{$dbtable}` WHERE `{$dbtable}`.`parent_users` = '{$userid}' AND `{$dbtable}`.`status` = '0'";
        else
        {
            $localid = filter_input(INPUT_POST, 'localid', FILTER_SANITIZE_STRING);
            if($localid === false || $localid === null)
                $localid = false;
            $query = "DELETE FROM `{$dbname}`.`{$dbtable}` WHERE (`{$dbtable}`.`status` = '0')" . ($localid === false ? '' : " AND (`{$dbtable}`.`localid` = '{$localid}')");
        }
        $link->query($query);
        if($link->connect_errno)
            exit('{ "result": "0", "error": "' . $link->error . '" }');

        exit('{ "result": "1" }');

    case 'clear': // Очищаем базу
        if($internetserver)
            $query = "DELETE FROM `{$dbname}`.`{$dbtable}` WHERE `{$dbtable}`.`parent_users` = '{$userid}'";
        else
        {
            $localid = filter_input(INPUT_POST, 'localid', FILTER_SANITIZE_STRING);
            if($localid === false || $localid === null)
                $query = "TRUNCATE TABLE `{$dbname}`.`{$dbtable}`";
            else
                $query = "DELETE FROM `{$dbname}`.`{$dbtable}` WHERE `{$dbtable}`.`localid` = '{$localid}'";
        }
        $link->query($query);
        if($link->connect_errno)
            exit('{ "result": "0", "error": "' . $link->error . '" }');

        exit('{ "result": "1" }');

    case 'add':

        if(array_key_exists('content', $_REQUEST))
        {
            ////$content = filter_input(INPUT_POST, 'content', FILTER_SANITIZE_STRING);
            $content = $_REQUEST['content'];
            ////$content = mb_convert_encoding($content, 'utf-8', mb_detect_encoding($content));
            if($win1251)
                $content = iconv('CP1251','UTF-8',$content); // БЫЛО!!!
            //file_put_contents('1.txt', $content);
            if($content === false || $content === null)
                if($win1251)
                    exit(iconv("UTF-8", "windows-1251//TRANSLIT", '{ "result": "0", "error": "В запросе отсутствует или неправильный контент" }'));
                else
                    exit('{ "result": "0", "error": "Missing or invalid content in request" }');

            $localid = filter_input(INPUT_POST, 'localid', FILTER_SANITIZE_STRING);
            if($localid === false || $localid === null || isset($internetserver))
                $localid = false;

            $status = filter_input(INPUT_POST, 'status', FILTER_VALIDATE_INT);
            if($status === false || $status === null || $status === '0')
                $status = '0';
            else
            {
                $res = $link->query("SELECT * FROM `{$dbname}`.`{$dbtable}` as `dbtable` WHERE (`dbtable`.`status` = '{$status}')" . (isset($internetserver) ? " AND (`dbtable`.`parent_users` = '{$userid}')" : ($localid === false ? '' : " AND (`dbtable`.`localid` = '{$localid}')")));
                if($link->connect_errno)
                    exit('{ "result": "0", "error": "' . $link->error . '" }');

                if($res->num_rows > 0)            
                    exit('{ "result": "1", "insert": "0" }');
            }            

            $query = $link->prepare("INSERT INTO `{$dbname}`.`{$dbtable}` (`status`,  `content`". (isset($internetserver) ? ", `parent_users`" : ($localid === false ? '' : ", `localid`")) . ") VALUES ('{$status}', ?" . (isset($internetserver) ? ", '{$userid}')" : ($localid === false ? ')' : ", '{$localid}')")));
            $query->bind_param('s', $content);
            $res = $query->execute();
            $query->close();

            //file_put_contents('1.d', $content);

            if(! $res)
                exit('{ "result": "0", "error": "' . $link->error . '" }');
        }

        exit('{ "result": "1", "insert": "1" }');

    case 'create':
        $link->query("CREATE DATABASE IF NOT EXISTS `{$dbname}`");
        if($link->connect_errno)
            exit('{ "result": "0", "error": "' . $link->error . '" }');

        $link->query("CREATE TABLE IF NOT EXISTS `{$dbname}`.`{$dbtable}` (`id` INT(15) NOT NULL AUTO_INCREMENT,
`content` TEXT,
`status` INT," . (isset($internetserver) ? "
`parent_users` INT,
INDEX (`parent_users`)," : "
`localid` VARCHAR(20),
INDEX (`localid`),") . "
PRIMARY KEY(`id`))
CHARACTER SET utf8 
COLLATE utf8_general_ci");
        if($link->connect_errno)
            exit('{ "result": "0", "error": "' . $link->error . '" }');

        exit('{ "result": "1" }');

    case 'get':
        $id = filter_input(INPUT_POST, 'id', FILTER_VALIDATE_INT);
        if($id === false || $id === null)
            if($win1251)
                exit(iconv("UTF-8", "windows-1251//TRANSLIT", '{ "result": "0", "error": "В запросе отсутствует id записи" }'));
            else
                exit('{ "result": "0", "error": "There is no record id in the request" }');

        $localid = filter_input(INPUT_POST, 'localid', FILTER_SANITIZE_STRING);
        if($localid === false || $localid === null || isset($internetserver))
            $localid = false;

        $res = $link->query("SELECT * FROM `{$dbname}`.`{$dbtable}` as `dbtable` WHERE (`dbtable`.`id` > '{$id}')" . (isset($internetserver) ? " AND (`dbtable`.`parent_users` = '{$userid}')" : ($localid === false ? '' : " AND (`dbtable`.`localid` = '{$localid}')")));
        if($link->connect_errno)
            exit('{ "result": "0", "error": "' . $link->error . '" }');

        $resarray = array();
        while($obj = $res->fetch_object())
            $resarray[] = $obj;
        
        if(count($resarray) == 0)
            exit('{ "result": "1" }');

        exit(json_encode(array('result' => '1', 'content' => $resarray)));     
}

echo $win1251 ? iconv("UTF-8", "windows-1251//TRANSLIT", '{ "result": "0", "error": "Неправильный запрос" }') : '{ "result": "0", "error": "Неправильный запрос" }';
?>
